SystemOrganization addCategory: #'Phidget-VMMaker-Plugins'!
SystemOrganization addCategory: #Phidget!

SmartSyntaxInterpreterPlugin subclass: #PhidgetPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-VMMaker-Plugins'!

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/6/2009 17:20'!
hasHeaderFile
	"If there is a single intrinsic header file to be associated with the plugin, here is where you want to flag"
	^true! !

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/18/2009 17:58'!
requiresCrossPlatformFiles
	"default is ok for most, any plugin needing platform specific files must say so"
	^true! !

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/18/2009 17:57'!
requiresPlatformFiles
	"this plugin requires platform specific files in order to work"
	^true! !

!PhidgetPlugin methodsFor: 'as yet unclassified' stamp: 'pt 4/19/2009 15:11'!
ifKitValueOf: oop
	"Return a pointer to the first byte of the phidget_ifKit record within the given Smalltalk bytes object, or nil if oop is not an phidget_ifKit record."

	self returnTypeC: 'phidget_ifKit *'.
	interpreterProxy success:
		((interpreterProxy isIntegerObject: oop) not and:
		 [(interpreterProxy isBytes: oop) and:
		 [(interpreterProxy slotSizeOf: oop) = (self cCode: 'sizeof(phidget_ifKit)')]]).
	interpreterProxy failed ifTrue: [^ nil].
	^ self cCode: '(phidget_ifKit *) (oop + 4)'! !

!PhidgetPlugin methodsFor: 'as yet unclassified' stamp: 'pt 4/19/2009 14:13'!
initialiseModule
	"Initialise the module"
	self export: true.
	^ self cCode: 'phidgetInitialise()' inSmalltalk:[true]! !

!PhidgetPlugin methodsFor: 'primitives' stamp: 'pt 4/19/2009 16:19'!
primAttached: phidHandle
	| phid |
	self var: #phid type: 'phidget_ifKit *'.
	self primitive: 'primAttached' parameters: #(Oop ).
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: (self cCode: 'phidgetIfKitAttached(phid)')! !

!PhidgetPlugin methodsFor: 'primitives' stamp: 'pt 4/19/2009 14:12'!
primClose: phidHandle
	| phid |
	self var: #phid type: 'phidget_ifKit *'.
	self primitive: 'primClose' parameters: #(Oop ).
	phid := self ifKitValueOf: phidHandle.
	^ self cCode: 'phidgetIfKitClose(phid)'! !

!PhidgetPlugin methodsFor: 'primitives' stamp: 'pt 4/19/2009 17:04'!
primGetSensorValue: phidHandle At: index
	| phid |
	self var: #phid type: 'phidget_ifKit *'.
	self primitive: 'primGetSensorValue' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: (self cCode: 'phidgetIfKitGetSensorValue(phid, (int)index)')! !

!PhidgetPlugin methodsFor: 'primitives' stamp: 'pt 4/20/2009 09:38'!
primIfKitCreate
	| phidOop phid |
	self var: #phid type: 'phidget_ifKit *'.
	self primitive: 'primIfKitCreate' parameters: #( ).
	
	phidOop := interpreterProxy instantiateClass: interpreterProxy classByteArray indexableSize: (self cCode: 'sizeof(phidget_ifKit)').
	phid := self ifKitValueOf: phidOop.
	interpreterProxy failed ifFalse: [self cCode: 'phidgetIfKitResetSemaphores(phid)'].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'primitives' stamp: 'pt 4/20/2009 09:45'!
primOpen: phidOop withSerial: serial
	| phid |
	self var: #phid type: 'phidget_ifKit *'.
	self primitive: 'primOpen' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidOop.
	interpreterProxy failed ifFalse: [self cCode: 'phidgetIfKitOpen(phid, (int)serial)'].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'primitives' stamp: 'pt 4/20/2009 09:46'!
primOpenAny: phidOop
	| phid |
	self var: #phid type: 'phidget_ifKit *'.
	self primitive: 'primOpenAny' parameters: #(Oop ).
	
	phid := self ifKitValueOf: phidOop.
	interpreterProxy failed ifFalse: [self cCode: 'phidgetIfKitOpenAny(phid)'].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'primitives' stamp: 'pt 4/19/2009 17:04'!
primSetOnChange: phidHandle SemaphoreIndex: semaIndex
	| phid |
	self var: #phid type: 'phidget_ifKit *'.
	self primitive: 'primSetOnChange' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: (self cCode: 'phidgetIfKitSetOnSensorChangeSemaIndex(phid, (int)semaIndex)')! !

!PhidgetPlugin methodsFor: 'as yet unclassified' stamp: 'pt 4/18/2009 20:06'!
shutdownModule
	"Shutdown the module"
	self export: true.
	^self cCode: 'phidgetShutdown()' inSmalltalk:[true]! !

Object subclass: #Phidget
	instanceVariableNames: 'semaphore opened values ifKit onSensorChange'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget'!

!Phidget methodsFor: 'as yet unclassified' stamp: 'pt 4/20/2009 15:04'!
callbackProcess
	[opened] whileTrue: [
		onSensorChange value: self.
		semaphore wait.
		]! !

!Phidget methodsFor: 'as yet unclassified' stamp: 'pt 4/18/2009 20:49'!
close
	"close the interfaceKit Phidget"
	opened ifFalse: [^ self]. "already closed"
	self primClose: ifKit.
	opened := false.
	semaphore signal.
	Smalltalk unregisterExternalObject: semaphore.
	semaphore := nil! !

!Phidget methodsFor: 'as yet unclassified' stamp: 'pt 4/20/2009 15:04'!
initialize
	super initialize.
	opened := false.
	onSensorChange := [:phid |].
	ifKit := self primIfKitCreate.! !

!Phidget methodsFor: 'as yet unclassified' stamp: 'pt 4/20/2009 10:15'!
onSensorChangeDo: aBlock
	onSensorChange := aBlock.! !

!Phidget methodsFor: 'as yet unclassified' stamp: 'pt 4/20/2009 10:36'!
openAny
	"opens any InterfaceKit Phidget"
	| semaIndex |
	ifKit ifNil: [self error:'Could not open InterfaceKit!!'. ^ self].
	semaphore := Semaphore new.
	semaIndex := Smalltalk registerExternalObject: semaphore.
	(self primSetOnChange: ifKit SemaphoreIndex: semaIndex) ifNil: [
		Smalltalk unregisterExternalObject: semaphore.
		semaphore := nil.
		self error: 'could not register callback process semaphore!!'.
		^ self].
	self primOpenAny: ifKit.
	opened := true.
	[self callbackProcess] fork.! !

!Phidget methodsFor: 'primitives' stamp: 'pt 4/20/2009 09:16'!
primClose: phid
	"close the interfaceKit Phidget"
	<primitive: 'primClose' module: 'PhidgetPlugin'>
	^ nil! !

!Phidget methodsFor: 'primitives' stamp: 'pt 4/20/2009 09:16'!
primGetSensorValue: phid At: sensorIndex
	"gets the sensor value (0-1000) at the analog input with the given index"
	<primitive: 'primGetSensorValue' module: 'PhidgetPlugin'>
	^ nil! !

!Phidget methodsFor: 'primitives' stamp: 'pt 4/20/2009 10:07'!
primIfKitCreate
	"reset the interfaceKit Phidget (Semaphores and Handle)"
	<primitive: 'primIfKitCreate' module: 'PhidgetPlugin'>
	^ nil! !

!Phidget methodsFor: 'primitives' stamp: 'pt 4/20/2009 09:51'!
primOpen: phid withSerial: serial
	"opens the phidget with the given serialNumber InterfaceKit Phidget"
	<primitive: 'primOpen' module: 'PhidgetPlugin'>
	^ nil! !

!Phidget methodsFor: 'primitives' stamp: 'pt 4/20/2009 09:54'!
primOpenAny: phid
	"opens any available InterfaceKit Phidget"
	<primitive: 'primOpenAny' module: 'PhidgetPlugin'>
	^ nil! !

!Phidget methodsFor: 'primitives' stamp: 'pt 4/20/2009 09:16'!
primSetOnChange: phid SemaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when a SensorValue changed."
	<primitive: 'primSetOnChange' module: 'PhidgetPlugin'>
	^ nil! !

!Phidget methodsFor: 'as yet unclassified' stamp: 'pt 4/20/2009 15:04'!
sensorValue: sensorIndex
	"gets the sensor value (0-1000) at the analog input with the given index"

	sensorIndex >= 1 & sensorIndex<=8
		ifTrue:[^ self primGetSensorValue: ifKit At: sensorIndex-1].
	^ nil! !

!Phidget methodsFor: 'as yet unclassified' stamp: 'pt 4/20/2009 10:19'!
values
	^values! !

BorderedMorph subclass: #IfKitSlider
	instanceVariableNames: 'pick max min maxValue minValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget'!

!IfKitSlider methodsFor: 'as yet unclassified' stamp: 'pt 4/20/2009 11:32'!
initialize
	super initialize.
	self color: Color blue lighter;
		width: 50;
		height: 200.
	pick := BorderedMorph new.
	pick color: Color black;
		width: 40;
		height: 20.
	self addMorph: pick.
	pick
		left: (self left + 5);
		top: (self top + 5).
	min := 0.
	max := (self bottom -5)-(self top +5)-pick height.
	minValue :=0.
	maxValue :=100.
	! !

!IfKitSlider methodsFor: 'as yet unclassified' stamp: 'pt 4/20/2009 11:31'!
rawValue: aNumber
	"0 <= aNumber <= 1000"
	"pick top: self bottom - 5 - pick height - (aNumber/1000*max)."
	pick top: self top + 5 + ((1000-aNumber)/1000*max)! !

!IfKitSlider methodsFor: 'as yet unclassified' stamp: 'pt 4/20/2009 11:10'!
setMin: minV max: maxV
	minValue := minV.
	maxValue := maxV.! !

!IfKitSlider methodsFor: 'as yet unclassified' stamp: 'pt 4/20/2009 11:12'!
value
	^ (pick top - self top -5)*maxValue/minValue! !
